# Global Search

## [v0.4.0](https://github.com/Oppzippy/GlobalSearch/tree/v0.4.0) (2022-08-13)
[Full Changelog](https://github.com/Oppzippy/GlobalSearch/compare/v0.3.0...v0.4.0) [Previous Releases](https://github.com/Oppzippy/GlobalSearch/releases)

- Store word index as sorted array rather than trie  
    Search performance is fine for both data structures, but it takes  
    2-3 times longer to create the trie than the sorted array.  
- Don't strip escape sequences unless we need the result  
- Add battle pet source and description to extraSearchText  
- Add mount descriptions and sources to extraSearchText  
- Add secure slash commands to slash commands provider  
- Update secure slash commands  
- Add execute flag to update-secure-slash-commands.sh script  
- Fix copy and paste mistake  
- Fix typos  
- Add generated list of secure slash commands  
- Fetch emotes from hash\_EmoteTokenList  
- Fetch slash commands from hash\_SlashCmdList  
    Scanning _G will pick up some more command such as everything in  
    SecureCmdList, but it's much slower. In the future, maybe package a list  
    of everything in SecureCmdList with the addon.  
- Rename QueryMatcherSearchContext to ShortTextSearchContext  
    Its implementation is specific to ShortTextQueryMatcher, so the name  
    should reflect that.  
- Don't CondenseMatchRanges if not necessary  
    If there's only one match range, CondenseMatchRanges will change nothing  
- Improve QueryMatcherSearchContext result reuse condition  
- Improve FullTextWordIndex performance when words are repeated  
    If a word appears more than once in the query, we only need to search it  
    once. The results can be given more weight for each time the word  
    appears.  
    Word results are cached for later searches.  
- Fix CombinedSearchContext deduplication  
    FullTextSearchContext was returning the wrong type from its Search  
    function  
    SearchContextItems from different contexts will be different, but their  
    items will be the same.  
- Fix full text search running with an empty query  
- Remove option to not search spell descriptions  
    Now that we have full text search, unexpected results from spell  
    descriptions won't be an issue.  
- Include full text search results after short text  
    Only full text can be used for searching extraSearchText  
- Add full text search  
- Decrease weight of match string length  
    100 per character is way too much when compared with 100 per match under  
    prioritize fewer matches  
- Update tests to match new behavior  
- Fix matches using extraText not being last  
- Score items for sorting rather than having a fixed priority  
- Group together match ranges when possible  
- Reword building\_achievement\_cache locale string  
- Add default value for achievement cache  
- Cache all achievements in SavedVariables  
    GetAchievementInfo is really slow so this is pretty much the only  
    option. The cache will reset on new ToC versions. If we need to modify  
    the cache in the future, we can clear it if there's no addon version  
    field and add one going forward.  
    The cache could be distributed with the addon, but then updates will be  
    required when new achievements are added.  
    I tried using LibSerialize and AceSerializer to serialize the cache, but  
    both take 300+ ms for me. That plus the 150 for compression using  
    LibDeflate would make this by far the slowest provider.  
- Fix duplicate achievements  
- Fix sibling achievements  
- Add achievement tooltip  
- Use coroutine for bag item iterator  
- Simplify achievement iterators using coroutines  
- Implement achievement action  
- Remove print  
- Improve query matcher performance  
    Fewer characters are iterated over in lua since most of the work is done  
    by string.find. This decreases execution time by around 66%.  
- Include all achievements in chains  
    Before, only the achievement with its own listing in the achievement ui  
    would be listed. Now, the previous/next achievements will be listed as  
    well.  
- Fix item name FontString overflowing into category FontString  
- Add achievements provider  
    Disabled by default for now due to the awful performance  
-  Fix types for sumneko/lua-language-server v3.5.0  
    Before this version, ---@class would apply the class to everything on  
    the next line, so _ and ns would both get the ns class. Now, positioning  
    is taken into account, so only _ is affected by ---@class.  
